using UnityEngine;
using System.Collections;
using System;
using UnityEngine.Events;
namespace Mod
{

    public class Mod
    {
        public static void Main()
        {   
            // Load The Emotions
            DynEmoties.bleeding = ModAPI.LoadTexture("sprites/bleeding.png");
            DynEmoties.bone = ModAPI.LoadTexture("sprites/bone.png");
            DynEmoties.cry = ModAPI.LoadTexture("sprites/cry.png");
            DynEmoties.cry2 = ModAPI.LoadTexture("sprites/cry2.png");
            DynEmoties.dead = ModAPI.LoadTexture("sprites/dead.png");
            DynEmoties.flesh = ModAPI.LoadTexture("sprites/flesh.png");
            DynEmoties.nope = ModAPI.LoadTexture("sprites/nope.png");
            DynEmoties.notoxygen = ModAPI.LoadTexture("sprites/notoxygen.png");
            DynEmoties.shock = ModAPI.LoadTexture("sprites/shock.png");
            DynEmoties.simply = ModAPI.LoadTexture("sprites/simply.png");
            DynEmoties.sleepy = ModAPI.LoadTexture("sprites/asleep.png");
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Realistic Human",
                    DescriptionOverride = "This Human has Emotions.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("sprites/HumIcon.png"),
                    AfterSpawn = (Instance) =>
                    {
                        UnityEngine.Object.Destroy(Instance.GetComponent<SyringeBehaviour>());
                        Instance.GetOrAddComponent<DynEmoties>();
                       
                       //load textures for each layer (see Human textures folder in this repository)
                       var skin = ModAPI.LoadTexture("sprites/simply.png");
                       var flesh = ModAPI.LoadTexture("sprites/flesh.png");
                       var bone = ModAPI.LoadTexture("sprites/bone.png");

                       var person = Instance.GetComponent<PersonBehaviour>();

                       person.SetBodyTextures(skin, flesh, bone, 2);

                    }
                }
            );
        }
    }


    public class DynEmoties : MonoBehaviour
    {

        PersonBehaviour person;
        public static Texture2D bleeding;
        public static Texture2D cry;
        public static Texture2D cry2;
        public static Texture2D dead;
        public static Texture2D flesh;
        public static Texture2D nope;
        public static Texture2D notoxygen;
        public static Texture2D shock;
        public static Texture2D simply;
        public static Texture2D bone;
        public static Texture2D sleepy;
        public LimbBehaviour limb;
        public bool painAlways = false;
        bool crying = false;
        string animNow = "null";

        protected virtual void Start()
        {
            person = gameObject.GetComponent<PersonBehaviour>();
            limb = gameObject.GetComponent<LimbBehaviour>();
            //what do you want to find here?)
        }
        public void Update()
        {
            bool live = person.IsAlive();
            if (live == true)
            {
                if (person.OxygenLevel < 0.7)
                {
                    if (animNow != "notoxy")
                    {
                        person.SetBodyTextures(notoxygen, flesh, bone, 1);
                        animNow = "notoxy";
                    }
                }
                /*else if (person.OxygenLevel < 0.7 && person.PainLevel > 0.5f)
                {
                    if (animNow != "notoxy")
                    {
                        person.SetBodyTextures(notoxygen, flesh, bone, 1);
                        animNow = "notoxy";
                    }
                }*/
                else if (person.Consciousness < 0.8f)
                {
                    if (animNow != "sleepy")
                    {
                        person.SetBodyTextures(sleepy, flesh, bone, 1);
                        animNow = "sleepy";
                    }
                }
                else if (person.ShockLevel > 0.5f || person.PainLevel > 0.5f)
                {
                    if (!crying)
                    {
                        StartCoroutine(Plak());
                    }
                }

                else if (!person.IsTouchingFloor & (person.ActivePose.Name == "Rest" | person.ActivePose.Name == "Fetus" | person.ActivePose.Name == "Flailing"))
                {
                    if (animNow != "notoxy")
                    {
                        person.SetBodyTextures(notoxygen, flesh, bone, 1);
                        animNow = "notoxy";
                    }

                }
                else
                {
                    if (animNow != "simply")
                    {
                        person.SetBodyTextures(simply, flesh, bone, 1);
                        animNow = "simply";
                    }
                }
            }
            else
            {
                if (animNow != "dead")
                {
                    person.SetBodyTextures(dead, flesh, bone, 1);
                    animNow = "dead";
                }
                StopAllCoroutines();
            }

        }
        IEnumerator Plak()
        {

            //cry loop
            crying = true;
            yield return new WaitForSeconds(0.1f);
            person.SetBodyTextures(cry, flesh, bone, 1);
            yield return new WaitForSeconds(0.1f);
            person.SetBodyTextures(cry2, flesh, bone, 1);
            crying = false;
        }

    }

}
